#ifndef _GNYA_CLOCK_FACE_
#define _GNYA_CLOCK_FACE_

class GnyaClockFace
{
public:
	GnyaClockFace(void) {};
	~GnyaClockFace(void) {};

	void GetBezierPoints( int tm, int width, int height, void *pxp, bool org = true );
	void GetBezierCurve( int div, void *pxp, void *ppp, bool friendly = false, int width = 0, int height = 0, int *startp = 0, int *count = 0 );
	bool GetClockDot( int h, int type, int width, int height, void *prect );

	virtual void UpdateSize( int width, int height, void *param ) = 0;
	virtual void UpdateSettings(void) = 0;
	virtual void Draw( int width, int height, int tm, int day, void *param ) = 0;

protected:
	static const double cv_data[13][4];

	virtual void SetX( void *p, int idx, double value ) = 0;
	virtual void SetY( void *p, int idx, double value ) = 0;
	virtual double GetX( void *p, int idx ) = 0;
	virtual double GetY( void *p, int idx ) = 0;
	virtual void SetRect( void *p, double x, double y, double width, double height ) = 0;
};

#endif//_GNYA_CLOCK_FACE_
