#ifndef _GNYA_CLOCK_FACE_GDI_
#define _GNYA_CLOCK_FACE_GDI_

#include "GnyaClockFace.h"
#include "AppProfile.h"
#include <vector>

class GnyaFaceGdi : public GnyaClockFace
{
public:
	GnyaFaceGdi( AppProfile &ref );
	~GnyaFaceGdi(void);

	void UpdateSize( int width, int height, void *param );
	void UpdateSettings(void);
	void Draw( int width, int height, int tm, int day, void *param );

protected:
	AppProfile &prof;
	std::vector<RECT> dots;
	HPEN handPen, dotPen;
	HBRUSH dotBrush;
	HFONT dayFont;

	void SetX( void *p, int idx, double value );
	void SetY( void *p, int idx, double value );
	double GetX( void *p, int idx );
	double GetY( void *p, int idx );
	void SetRect( void *p, double x, double y, double width, double height );

	void ShiftRect( RECT *inRect, RECT *outRect, int hShift, int vShift );
};

#endif//_GNYA_CLOCK_FACE_GDI_
