#ifndef _GNYA_CLOCK_FACE_GDIPLUS_
#define _GNYA_CLOCK_FACE_GDIPLUS_

#include "GnyaClockFace.h"
#include "AppProfile.h"
#include <vector>
#include <gdiplus.h>
#include "DynamicApi.h"

class GnyaFaceGdip : public GnyaClockFace
{
public:
	GnyaFaceGdip( AppProfile &ref );
	~GnyaFaceGdip(void);

	void UpdateSize( int width, int height, void *param );
	void UpdateSettings(void);
	void Draw( int width, int height, int tm, int day, void *param );

protected:
	int prevDay;
	AppProfile &prof;
	std::vector<Gdiplus::RectF> dots;
	QGraphicsTextApi qgt;
	Gdiplus::Pen handPen, backPen;
	Gdiplus::SolidBrush dotBrush, dayBrush;
	Gdiplus::GraphicsPath dayPath, *transformedPath;
	Gdiplus::Graphics *graphics;

	void SetX( void *p, int idx, double value );
	void SetY( void *p, int idx, double value );
	double GetX( void *p, int idx );
	double GetY( void *p, int idx );
	void SetRect( void *p, double x, double y, double width, double height );

	BOOL UpdateDayPath( int day = 0 );
	void TransformDayPath( int width, int height );
};

#endif//_GNYA_CLOCK_FACE_GDIPLUS_
