#include "StdAfx.h"
#include "Window.h"
#include <map>

static std::map<HWND,Window*> objectMap;

Window::Window(void)
	: m_lpszClass( NULL )
	, m_hAccelTable( NULL )
	, m_idIcon( 0 )
	, m_idMenu( 0 )
	, m_hbrBackground( (HBRUSH)(COLOR_WINDOW+1) )
	, m_style( WS_OVERLAPPEDWINDOW )
	, m_exStyle( 0 )
{
}

Window::~Window(void)
{
}

INT_PTR CALLBACK Window::_RootWndProc( HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam )
{
	CREATESTRUCT *cs;
	Window *wnd = NULL;
	INT_PTR iRet = 0;

	switch( uMsg )
	{
	case WM_CREATE:
		cs = (CREATESTRUCT*)lParam;
		if ( cs ) {
			wnd = (Window*)cs->lpCreateParams;
			objectMap[hWnd] = wnd;
			wnd->m_hWnd = hWnd;
		}
		break;
	}

	wnd = objectMap[hWnd];
	if ( wnd ) {
		iRet = wnd->WndProc( uMsg, wParam, lParam );
	}
	else {
		iRet = DefWindowProc( hWnd, uMsg, wParam, lParam );
	}

	// switchŌĂԂƃIuWFNgɔׂȂȂ̂ōŌ
	if ( uMsg == WM_DESTROY ) {
		objectMap.erase( hWnd );
	}

	return iRet;
}

BOOL Window::Create( TCHAR *lpszTitle, int x, int y, int w, int h, int nCmdShow, HWND hParent )
{
	BOOL bRet = FALSE;
	WNDCLASSEX wcex;

	do {
		wcex.cbSize			= sizeof(WNDCLASSEX);
		wcex.style			= CS_HREDRAW | CS_VREDRAW;
		wcex.lpfnWndProc	= (WNDPROC)_RootWndProc;
		wcex.cbClsExtra		= 0;
		wcex.cbWndExtra		= 0;
		wcex.hInstance		= hInst;
		wcex.hIcon			= LoadIcon(hInst, MAKEINTRESOURCE(m_idIcon));
		wcex.hCursor		= LoadCursor(NULL, IDC_ARROW);
		wcex.hbrBackground	= m_hbrBackground;
		wcex.lpszMenuName	= MAKEINTRESOURCE(m_idMenu);
		wcex.lpszClassName	= m_lpszClass;
		wcex.hIconSm		= NULL;

		if ( !RegisterClassEx(&wcex) ) {
			break;
		}

		m_hWnd = CreateWindowEx(m_exStyle,
								m_lpszClass,
								lpszTitle,
								m_style,
								x,
								y,
								w,
								h,
								hParent,
								NULL,
								hInst,
								(LPVOID)this );

		if ( m_hWnd ) {
			ShowWindow( m_hWnd, nCmdShow );
			UpdateWindow( m_hWnd );
			bRet = TRUE;
		}
	} while( FALSE );

	return bRet;
}

INT_PTR Window::RunMsgLoop( void )
{
	MSG msg;

	// C bZ[W [v:
	while( GetMessage( &msg, NULL, 0, 0 ) )
	{
		if ( !TranslateAccelerator( msg.hwnd, m_hAccelTable, &msg ) )
		{
			TranslateMessage( &msg );
			DispatchMessage( &msg );
		}
	}

	return (int) msg.wParam;
}
